<?php
require_once(_PS_ROOT_DIR_ . '/modules/adamspay/classes/AdamspayDeuda.php');
require_once(_PS_ROOT_DIR_ . '/modules/adamspay/classes/AdamspayApi.php');

use Adamspay\AdamspayApi;

class AdamspayGenerateLinkModuleFrontController extends ModuleFrontController
{
    
    public function postProcess()
    {
        $this->context = Context::getContext();
        $id_orden = Tools::getValue('id_order');

        if (!$id_orden) {
            $mensaje = 'Ha ocurrido un error al hacer el redireccionamiento';
            AdamspayLog::error($mensaje, __FUNCTION__);
            Tools::redirect($this->context->link->getModuleLink($this->module->name, 'redirect', ['action' => 'error', 'mensaje' => $mensaje], true));

        } else {
            $deuda_local = AdamspayDeuda::obtenerDeudaPorIdOrden($id_orden);
            $orden = new Order($id_orden);
            if(empty($deuda_local)){
                $mensaje = 'No existe deuda local asociada a la orden ';
                AdamspayLog::error($mensaje.$id_orden, __FUNCTION__);
                Tools::redirect($this->context->link->getModuleLink($this->module->name, 'redirect', ['action' => 'error', 'mensaje' => $mensaje], true));
            }

            if($orden->current_state <> Configuration::get('PS_OS_CANCELED')){
                if($deuda_local['estado_deuda'] == AdamspayDeuda::DEUDA_CANCELADA){
                    $total = $orden->total_paid;
                    $moneda = new Currency($orden->id_currency);
                    $adamspay = new AdamspayApi;
                    $deuda_remota = $adamspay->crearDeuda($total, $orden->id, $moneda->iso_code);

                    if(isset($deuda_remota['meta']) && $deuda_remota['meta']['status'] == 'success'){
                        $deuda_local = new AdamspayDeuda($deuda_local['row_id']);
                        $deuda_local->estado_orden = $orden->current_state;
                        $deuda_local->estado_deuda = AdamspayDeuda::DEUDA_PENDIENTE;

                        if(!$deuda_local->save()){
                            $mensaje = 'La deuda no ha podido ser guardada localmente';
                            AdamspayLog::error($mensaje, __FUNCTION__);
                        }

                        Tools::redirect($deuda_remota['debt']['payUrl']);

                    }else{
                        $mensaje = 'No se ha podido crear la deuda en AdamsPay. Intentelo nuevamente';
                        Tools::redirect($this->context->link->getModuleLink($this->module->name, 'redirect', ['action' => 'error', 'mensaje' => $mensaje], true));
                    }
                }
                Tools::redirect($deuda_local['url_pago']);
            }else{
                $mensaje = 'Su orden ha sido cancelada';
                Tools::redirect($this->context->link->getModuleLink($this->module->name, 'redirect', ['action' => 'error', 'mensaje' => $mensaje], true));
            }

        }
    }
}
